#求矢量v1到v2的右旋转角度(R)
def rightAngleBetween(v1,v2,normal)
  r=v1.angle_between v2
  vz=v1*v2
  vt=normal*v2
  r=2*Math::PI-r if v1%vt<0
  r
end

#求两矢量的一定比例的脚分线，n是百分比0-100
def divideVector(v1,v2,n,vec_z)
  po=Geom::Point3d.new 0,0,0
  #v_z=Geom::Vector3d.new 0,0,1
  r=rightAngleBetween(v1,v2,vec_z)
  t=Geom::Transformation.rotation po,vec_z,-r*n/100
  v1.transform t
end

#将矢量按照一定角度排序，a_v[0]为起始
def sortVectors(a_v,v_z)
  a_r=[]
  #v_z=Geom::Vector3d.new 0,0,1
  v_start=a_v[0]
  a_r=a_v.sort_by{|i| rightAngleBetween(v_start,i,v_z)}
  a_r
end

#将矢量绘制成线
def drawVector(vec,point)
  model=Sketchup.active_model
  ents=model.active_entities
  po=Geom::Point3d.new 0,0,0
  vo=po.vector_to point
  vend=vo+vec
  pend=Geom::Point3d.new vend.x,vend.y,vend.z
  ents.add_edges point,pend
end

#求向右角最小的矢
def rightAngleMin(v,a_v,normal)
  r=rightAngleBetween(v,a_v[0],normal)
  return_v=a_v[0]
  a_v.each do |i|
    a=rightAngleBetween(v,i,normal)
    if a<r
      return_v=i
      r=a
    end
  end
  return_v
end

#求向右角最大的矢量
def rightAngleMax(v,a_v,normal)
  r=rightAngleBetween(v,a_v[0],normal)
  return_v=a_v[0]
  a_v.each do |i|
    a=rightAngleBetween(v,i,normal)
    if a>r
      return_v=i
      r=a
    end
  end
  return_v
end